package com.abcseo.ws2300;

import gnu.io.CommPortIdentifier;
import junit.framework.TestCase;

public class TemperatureTest extends TestCase {
	String comPort = "COM1";
	CommPortIdentifier portId;
	WS2300 weatherStation;
	TemperatureHumidity temp;

	public static void main(String[] args) {
		junit.textui.TestRunner.run(TemperatureTest.class);
	}

	public TemperatureTest(String arg0) {
		super(arg0);
	}

	/**
	 * Called prior to each test method
	 */
	protected void setUp() throws Exception {
		super.setUp();
		
		System.out.println("here");
		
		portId = CommPortIdentifier.getPortIdentifier(comPort);
		if (portId.getPortType() == CommPortIdentifier.PORT_SERIAL) {

			weatherStation = new WS2300();
			temp = new TemperatureHumidity(weatherStation);
		}
	}

	protected void tearDown() throws Exception {
		super.tearDown();
		
		weatherStation.close();
	}
	
	/**
	 * Group all temperature tests as they all rely on common setup and teardown
	 *
	 */
	public void testTemperature() {
		//outdoor();
		//dewpoint();
		outdoorMaxMin();
	}

	/**
	 * ensure outdoor temperature is within spec
	 */
	private void outdoor() {
		try {
		double od = temp.getOutdoorTemperature();
		if (od < -29.9 || od > 69.9) {
			fail("temperature out of range " + od);
			
		}
		} catch (Exception e)
		{fail("exception " + e);}
		

	}
	
	private void outdoorMaxMin() {
		TemperatureHumidity.MaxMin mm = temp.getOutdoorMaxMin();
		
		if (mm.temp_max < -29.9 || mm.temp_max > 69.9) {
			fail("maximum temperature out of range " + mm.temp_max);
			
		}
	}

	private void dewpoint() {
	}


	private void getIndoor() {
	}

	private void getCloudBaseAGR() {
	}


	private void getAltitudeUnits() {
	}

}
